import swarm.*;
import swarm.activity.*;
import swarm.defobj.*;
import swarm.objectbase.*;
import swarm.space.*;
import swarm.collections.*;
import java.util.*;
import java.util.function.*;

public class ModelSwarm extends SwarmImpl {
    public int worldXSize, worldYSize;

    BackgroundSpace backgroundSpace;
    Grid2d world;

    swarm.collections.List bugList;
    ActionGroup modelActions;
    Schedule modelSchedule;

    ArrayList<BugCreator> creators;
    // xɕ\Bug̎ނ𑝂₵΂𑝂₷
    int bugCreatorNum = 2;
    // Bug̊ep^̏l (sɓIɕύX\)
    // swarm.collections.Listjava.util.ListĂă...
    java.util.List<Integer>   bugType               = Arrays.asList(2, 1);
    java.util.List<Integer>   moveType              = Arrays.asList(2, 3);
    java.util.List<Double>    bugDensity            = Arrays.asList(0.004, 0.004);
    java.util.List<Integer>   bugNum                = Arrays.asList(-1, 1);
    java.util.List<Float>     minSpeed              = Arrays.asList(1.0f, 1.5f);
    java.util.List<Float>     defaultSpeed          = Arrays.asList(1.5f, 2.0f);
    java.util.List<Float>     maxSpeed              = Arrays.asList(1.5f, 2.0f);
    java.util.List<Float>     accel                 = Arrays.asList(1.05f, 1.0f);
    java.util.List<Float>     gravityWeight         = Arrays.asList(0.04f, 0.04f);
    java.util.List<Float>     nearWeight            = Arrays.asList(0.01f, 0.01f);
    java.util.List<Float>     repulRadian           = Arrays.asList(2.0f, 2.0f);
    java.util.List<Float>     avoidRadian           = Arrays.asList(20.0f, 30.0f);
    java.util.List<Float>     orientRadian          = Arrays.asList(16.0f, 10.0f);
    java.util.List<Float>     searchRadian          = Arrays.asList(32.7f, 32.7f);
    java.util.List<Float>     searchAngle           = Arrays.asList(360.0f, 360.0f);
    java.util.List<Float>     stdRotate             = Arrays.asList(0.02f, 0.02f);
    java.util.List<Float>     maxRotate             = Arrays.asList(5.0f, 2.0f);
    java.util.List<Float>     maxRotateInAvoiding   = Arrays.asList(8.0f, 2.0f);
    java.util.List<Integer>   trailingNum           = Arrays.asList(5, 5);

    public ModelSwarm(Zone aZone) {
        super(aZone);

        EmptyProbeMap probeMap;
        probeMap = new EmptyProbeMapImpl(aZone, this.getClass());

        probeMap.addProbe(
        Globals.env.probeLibrary.getProbeForVariable$inClass(
        "worldXSize",
        this.getClass()));
        probeMap.addProbe(
        Globals.env.probeLibrary.getProbeForVariable$inClass(
        "worldYSize",
        this.getClass()));
        Globals.env.probeLibrary.setProbeMap$For(probeMap, this.getClass());
    }

    public Object setProbeDisplay() {
        // creator𐶐
        creators = new ArrayList<BugCreator>();
        for (int i = 0; i < bugCreatorNum; i++) {
            creators.add(new BugCreator(this, bugType.get(i), moveType.get(i), bugDensity.get(i), bugNum.get(i), defaultSpeed.get(i), minSpeed.get(i), maxSpeed.get(i), accel.get(i), gravityWeight.get(i), nearWeight.get(i), repulRadian.get(i), avoidRadian.get(i), orientRadian.get(i), searchRadian.get(i), searchAngle.get(i), stdRotate.get(i), maxRotate.get(i), maxRotateInAvoiding.get(i), trailingNum.get(i)));
        }
        // ǗIuWFNgɂčċAIɎs
        for (BugCreator creator : creators) {
            creator.setProbeDisplay();
        }
        // ɂĎs
        Globals.env.createArchivedProbeDisplay(this, "modelSwarm");
        return this;
    }

    public Object buildObjects() {
        int x, y;

        backgroundSpace = new BackgroundSpace(this, worldXSize, worldYSize);

        world = new Grid2dImpl(this, worldXSize, worldYSize);
        world.fillWithObject(null);

        bugList = new ListImpl(this);

        for (y = 0; y < worldYSize; y++) {
            for (x = 0; x < worldXSize; x++) {
                Optional<Bug> aBug = Optional.empty();
                for (int i = 0; i < creators.size(); i++) {
                    aBug = creators.get(i).create(this);
                    if (aBug.isPresent()) {
                        break;
                    }
                }
                if (aBug.isPresent()) {
                    aBug.get()
                        .setWorld(world)
                        .setX$Y(x, y);
                    bugList.addLast(aBug.get());
                }
            }
        }
        return this;
    }

    public Object buildActions() {
        modelActions = new ActionGroupImpl(this);
        try {
            modelActions.createActionForEach$message(
                bugList,
                new Selector(Class.forName("Bug"), "calc", false));
            modelActions.createActionForEach$message(
                bugList,
                new Selector(Class.forName("Bug"), "step", false));
        } catch (Exception e) {
            e.printStackTrace(System.err);
            System.exit(1);
        }

        modelSchedule = new ScheduleImpl(this, 1);
        modelSchedule.at$createAction(0, modelActions);
        return this;
    }

    public Activity activateIn(Swarm context) {
        super.activateIn(context);
        modelSchedule.activateIn(this);
        return getActivity();
    }

    public Grid2d getWorld() {
        return world;
    }

    public BackgroundSpace getBackgroundSpace() {
        return backgroundSpace;
    }

    public swarm.collections.List getBugList() {
        return bugList;
    }
}
