public class Vector2D {
    private float x;
    private float y;

    // 2DxN^̃NX
    // {IȖK:
    //  create -> VectorԂstatic֐,
    //  is, get -> j󃁃\bh,
    //  others -> j󃁃\bh (thisԂ)

    // RXgN^
    public Vector2D(float x, float y) {
        this.setValueByXY(x, y);
    }
    // l̎w
    public Vector2D setValueByXY(float x, float y) {
        this.x = x;
        this.y = y;
        return this;
    }
    public Vector2D setValueByNormDeg(float norm, float deg) {
        this.x = norm * (float) Math.cos(deg2rad(deg));
        this.y = norm * (float) Math.sin(deg2rad(deg));
        return this;
    }
    public Vector2D setValueByVector(Vector2D anotherVec) {
        this.x = anotherVec.x;
        this.y = anotherVec.y;
        return this;
    }

    // NX\bh
    // norm, degreew肵vector쐬ĕԂ
    public static Vector2D createVectorByXY(float x, float y) {
        return new Vector2D(x, y);
    }
    public static Vector2D createVectorByNormDeg(float norm, float deg) {
        return Vector2D.createVectorByXY(norm * (float) Math.cos(deg2rad(deg)), norm * (float) Math.sin(deg2rad(deg)));
    }
    // m͈̔͂w肵āimjl_vectorԂ
    public static Vector2D createRandomVec(float min, float max) {
        float norm = (float)Math.random() * (max - min) + min;
        float deg = (float)Math.random() * 2.0f * (float) Math.PI;
        return createVectorByNormDeg(norm, deg);
    }
    // xNgԂ
    public static Vector2D Zero() {
        return Vector2D.createVectorByXY(0.0f, 0.0f);
    }

    // j󃁃\bh
    // lZ
    public Vector2D add(Vector2D anotherVec) {
        this.x += anotherVec.x;
        this.y += anotherVec.y;
        return this;
    }
    public Vector2D sub(Vector2D anotherVec) {
        return this.mul(-1).add(anotherVec).mul(-1);
    }
    public Vector2D mul(float v) {
        this.x *= v;
        this.y *= v;
        return this;
    }
    // ςɃmclippingĕԂ
    public Vector2D clip(float min, float max) {
        if (this.isZero()) {
            return this.setValueByVector(Vector2D.createRandomVec(min, max));
        }
        float nowNorm = this.getNorm();
        if(nowNorm < min) {
            return this.mul(min / nowNorm);
        } else if(nowNorm > max) {
            return this.mul(max / nowNorm);
        } else {
            return this;
        }
    }
    // PʃxNgɂĕԂ
    public Vector2D unit() {
        if (this.isZero()) {
            return this;
        } else {
            return this.mul(1.0f / this.getNorm());
        }
    }

    // j󃁃\bh
    // Rs[Ԃ
    public Vector2D getCopyVec() {
        return Vector2D.createVectorByXY(this.x, this.y);
    }
    // [xNg𔻒肷
    public boolean isZero() {
        return this.x == 0.0f && this.y == 0.0f;
    }
    // Ԃ
    public float getDistance(Vector2D anotherVec) {
        Vector2D copy = this.getCopyVec();
        return copy.sub(anotherVec).getNorm();
    }
    // ςԂ
    public float getInnerProd(Vector2D anotherVec) {
        return this.x * anotherVec.x + this.y * anotherVec.y;
    }
    // xNgԂ̊pxԂ
    // v𐳂Ƃ-180x~ +180xŕԂ
    public float getInnerAngle(Vector2D anotherVec) {
        double radDiff = anotherVec.getRad() - this.getRad();
        if (radDiff < -Math.PI) {
            radDiff += 2.0 * Math.PI;
        } else if (radDiff > Math.PI) {
            radDiff -= 2.0 * Math.PI;
        }
        return (float) rad2deg(radDiff);
    }
    // pxԂ
    public float getAngle() {
        return (float) Vector2D.rad2deg(this.getRad());
    }
    // mԂ
    public float getNorm() {
        return (float)(Math.sqrt(x*x + y*y));
    }
    // WԂ (NaNB)
    public float getX() {
        if( Float.isNaN(x) ) {
            x = 0.0f;
        }
        return x;
    }
    public float getY() {
        if( Float.isNaN(y) ) {
            y = 0.0f;
        }
        return y;
    }
    // ɂ
    public String toString() {
        return "(" + x + ", " + y + ")";
    }

    // private\bh
    // deg -> rad
    private static double deg2rad(double deg) {
        return deg / 180.0f * Math.PI;
    }
    // rad -> deg
    private static double rad2deg(double rad) {
        return rad * 180.0f / Math.PI;
    }
    // pxԂ
    private double getRad() {
        double rad = Math.atan((double)(y/x));
        if( x < 0 ) {
            if( y > 0 ) {
                rad = Math.PI + rad;
            }
            else {
                rad = -Math.PI + rad;
            }
        }
        return rad;
    }
}
